GNU bug report logs - #22780
25.1.50; wrong average width picked for bold face for 7x13 X11 font

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Alex Khesin <alex@HIDDEN>; dated Tue, 23 Feb 2016 07:20:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 22780 <at> debbugs.gnu.org:


Received: (at 22780) by debbugs.gnu.org; 14 Sep 2016 16:49:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 14 12:49:39 2016
Received: from localhost ([127.0.0.1]:59709 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bkDNT-0001FL-LS
	for submit <at> debbugs.gnu.org; Wed, 14 Sep 2016 12:49:39 -0400
Received: from eggs.gnu.org ([208.118.235.92]:50389)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1bkDNS-0001F7-0y
 for 22780 <at> debbugs.gnu.org; Wed, 14 Sep 2016 12:49:38 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1bkDNI-0008I7-PG
 for 22780 <at> debbugs.gnu.org; Wed, 14 Sep 2016 12:49:32 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.4 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:51627)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1bkDNI-0008Hh-Lo; Wed, 14 Sep 2016 12:49:28 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:3732
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1bkDNG-0007JT-7V; Wed, 14 Sep 2016 12:49:27 -0400
Date: Wed, 14 Sep 2016 19:49:31 +0300
Message-Id: <838tuu8m04.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Philipp Stephani <p.stephani2@HIDDEN>
In-reply-to: <CAArVCkSbrfacq=aapuKqDw0=+dDDqBGyaoLj8=M92U9TjH6HLw@HIDDEN>
 (message from Philipp Stephani on Wed, 14 Sep 2016 14:15:47 +0000)
Subject: Re: bug#22780: 25.1.50;
 wrong average width picked for bold face for 7x13 X11 font
References: <CAPt6kTOJ4VDkoAjm96hSQ_oSQXvXjR_2RnFcpJsBRg70vijuxQ@HIDDEN>
 <CAArVCkSbrfacq=aapuKqDw0=+dDDqBGyaoLj8=M92U9TjH6HLw@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -7.2 (-------)
X-Debbugs-Envelope-To: 22780
Cc: 22780 <at> debbugs.gnu.org, alex@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -7.2 (-------)

> From: Philipp Stephani <p.stephani2@HIDDEN>
> Date: Wed, 14 Sep 2016 14:15:47 +0000
> 
> Alex Khesin <alex@HIDDEN> schrieb am Di., 23. Feb. 2016 um 08:20 Uhr:
> 
>  emacs 25 choses fonts with different average width for 7x13 font, making bold text take more horizontal
>  space. This is particularly a problem when using themes like https://github.com/bbatsov/zenburn-emacs
>  which use bold to hihglight matching parenthesis in show-paren-mode, causing characters to shift as
>  the cursor is moved from a parenthesis to a non-parenthesis character.
> 
>  Repro that demonstrates the problem in both 25 pretest 1 and current head (but is perfectly ok in emacs
>  24):
> 
>  $ emacs -Q --eval '(progn (set-face-font '\''default "7x13") (print (face-font "default")) (print (face-font
>  "bold")))'
> 
>  shows
>  -misc-fixed-medium-r-normal--13-120-75-75-c-70-iso8859-1
>  -misc-fixed-bold-r-normal--13-120-75-75-c-80-iso8859-1
> 
>  Notice the jump from 70 to 80 before the iso8859 component - that's the average width, and that's what
>  I believe is causing bold characters to render wider than non-bold ones. Both are 70 in emacs 24.
> 
> This appears to be a regression from Emacs 24. Would be great if somebody who has knowledge about this
> area could look into this. 

Alas, we don't have such experts on board.  Moreover, I could be
wrong, but I don't think font selection has seen any changes between
Emacs 24 and 25.

Perhaps the best way ahead is for someone who sees the problem to
revert changes since Emacs 24.5 to xftfont.c, ftfont.c, and font.c one
by one, and see which one causes the problem.  There are only a few
changes there that affect the code and font selection in particular.

Sorry, but I have no better advice.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#22780; Package emacs. Full text available.

Message received at 22780 <at> debbugs.gnu.org:


Received: (at 22780) by debbugs.gnu.org; 14 Sep 2016 14:16:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 14 10:16:06 2016
Received: from localhost ([127.0.0.1]:59642 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bkAys-0005ZQ-9i
	for submit <at> debbugs.gnu.org; Wed, 14 Sep 2016 10:16:06 -0400
Received: from mail-wm0-f52.google.com ([74.125.82.52]:35059)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1bkAyq-0005Rx-CM
 for 22780 <at> debbugs.gnu.org; Wed, 14 Sep 2016 10:16:04 -0400
Received: by mail-wm0-f52.google.com with SMTP id i130so51091651wmf.0
 for <22780 <at> debbugs.gnu.org>; Wed, 14 Sep 2016 07:16:04 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to;
 bh=iAdVteEx/O/Iu2LwOzR4N3Q90haYjLpgaDgm3tC2ZFs=;
 b=ZDM7B8wvWFyskbOolPHt1if/dtJyNisv61F8GUzjKhxrBtUDx6tVu2ikXcoM5VoV75
 6sldRfdSJA/dkDIvwlYy/4MSNDiP1FoD2mCQ9/5hcHgEE5kDNHLVOncknJbpa6/pNw1P
 QRYtDQTEFpyzx768qXqL4uE9R3qXP1nZ4h3NRJ7DNIzT0vMC4P2M26FWAdkwRoveR3l5
 U6VsjgbIALr18XicFhu51wz/5zzDS8sW6OUWhQik30XLGqpHhT1T27LvP9RtOhkfQdfq
 t2J326pM2tPaNEOeJO9/lwRfjw87vZif3PaikcJh/vXA/9psYp5sUjDo3DsOdELTwG3a
 YAxg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to;
 bh=iAdVteEx/O/Iu2LwOzR4N3Q90haYjLpgaDgm3tC2ZFs=;
 b=OayRK8DaEZzRtZ3b9TYxPvd7/lY0G48Pg+LGf6i0IEP2GNAGWIE9pPOmbYGvPzIlIZ
 ec7hu0cxZmpUAokXUzf6Sm1u/7FOZvOVzclrirJP78/QtrXNSDZa3rUQB8O82rdiFtkK
 X3xJMs75QMyS5OjljrDkirA9NtWCaCWYuF36cp2cuAhSD4SocGuluxfxNTAS2yDNmYDX
 HCJpSC+MYELN9g6KYhY+oytGmb1ZDkVLP26X4RBC6d+XgE+m/0bgcm4oBUQPAd8T3Zjt
 f9Hdr/jXJwR6Ya6WY8Pzo5uvBBWWeVCL7wlwCpwrP8dX0ZI3AODXoPLhMID9IVcxH/Mk
 bUYA==
X-Gm-Message-State: AE9vXwMnPvGMxHsJ2rxmSk7qAADXv8o0hjra2+lt9jXq03dy7Jcr0TZTf3kIDvuUOQL586oGMBUPsvZ4TWMUkA==
X-Received: by 10.28.153.70 with SMTP id b67mr11597269wme.84.1473862558385;
 Wed, 14 Sep 2016 07:15:58 -0700 (PDT)
MIME-Version: 1.0
References: <CAPt6kTOJ4VDkoAjm96hSQ_oSQXvXjR_2RnFcpJsBRg70vijuxQ@HIDDEN>
In-Reply-To: <CAPt6kTOJ4VDkoAjm96hSQ_oSQXvXjR_2RnFcpJsBRg70vijuxQ@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Wed, 14 Sep 2016 14:15:47 +0000
Message-ID: <CAArVCkSbrfacq=aapuKqDw0=+dDDqBGyaoLj8=M92U9TjH6HLw@HIDDEN>
Subject: Re: bug#22780: 25.1.50; wrong average width picked for bold face for
 7x13 X11 font
To: Alex Khesin <alex@HIDDEN>, 22780 <at> debbugs.gnu.org
Content-Type: multipart/alternative; boundary=001a114b32cc3d9f33053c785eed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 22780
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

--001a114b32cc3d9f33053c785eed
Content-Type: text/plain; charset=UTF-8

Alex Khesin <alex@HIDDEN> schrieb am Di., 23. Feb. 2016 um 08:20 Uhr:

> emacs 25 choses fonts with different average width for 7x13 font, making
> bold text take more horizontal space.  This is particularly a problem when
> using themes like https://github.com/bbatsov/zenburn-emacs which use bold
> to hihglight matching parenthesis in show-paren-mode, causing characters to
> shift as the cursor is moved from a parenthesis to a non-parenthesis
> character.
>
> Repro that demonstrates the problem in both 25 pretest 1 and current head
> (but is perfectly ok in emacs 24):
>
> $ emacs -Q --eval '(progn (set-face-font '\''default "7x13") (print
> (face-font "default")) (print (face-font "bold")))'
>
> shows
>   -misc-fixed-medium-r-normal--13-120-75-75-c-70-iso8859-1
>   -misc-fixed-bold-r-normal--13-120-75-75-c-80-iso8859-1
>
> Notice the jump from 70 to 80 before the iso8859 component - that's the
> average width, and that's what I believe is causing bold characters to
> render wider than non-bold ones.  Both are 70 in emacs 24.
>
>
This appears to be a regression from Emacs 24. Would be great if somebody
who has knowledge about this area could look into this.

--001a114b32cc3d9f33053c785eed
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">Alex K=
hesin &lt;<a href=3D"mailto:alex@HIDDEN">alex@HIDDEN</a>&gt; schrie=
b am Di., 23. Feb. 2016 um 08:20=C2=A0Uhr:<br></div><blockquote class=3D"gm=
ail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-le=
ft:1ex"><div dir=3D"ltr" class=3D"gmail_msg"><div class=3D"gmail_msg"><div =
class=3D"gmail_msg">emacs 25 choses fonts with different average width for =
7x13 font, making bold text take more horizontal space.=C2=A0 This is parti=
cularly a problem when using themes like <a href=3D"https://github.com/bbat=
sov/zenburn-emacs" class=3D"gmail_msg" target=3D"_blank">https://github.com=
/bbatsov/zenburn-emacs</a> which use bold to hihglight matching parenthesis=
 in show-paren-mode, causing characters to shift as the cursor is moved fro=
m a parenthesis to a non-parenthesis character.</div><div class=3D"gmail_ms=
g"><br class=3D"gmail_msg"></div><div class=3D"gmail_msg">Repro that demons=
trates the problem in both 25 pretest 1 and current head (but is perfectly =
ok in emacs 24):</div><div class=3D"gmail_msg"><br class=3D"gmail_msg"></di=
v><div class=3D"gmail_msg">$ emacs -Q --eval &#39;(progn (set-face-font &#3=
9;\&#39;&#39;default &quot;7x13&quot;) (print (face-font &quot;default&quot=
;)) (print (face-font &quot;bold&quot;)))&#39;</div><div class=3D"gmail_msg=
"><br class=3D"gmail_msg"></div><div class=3D"gmail_msg">shows</div><div cl=
ass=3D"gmail_msg"><div class=3D"gmail_msg">=C2=A0 -misc-fixed-medium-r-norm=
al--13-120-75-75-c-70-iso8859-1</div><div class=3D"gmail_msg">=C2=A0 -misc-=
fixed-bold-r-normal--13-120-75-75-c-80-iso8859-1</div></div><div class=3D"g=
mail_msg"><br class=3D"gmail_msg"></div><div class=3D"gmail_msg">Notice the=
 jump from 70 to 80 before the iso8859 component - that&#39;s the average w=
idth, and that&#39;s what I believe is causing bold characters to render wi=
der than non-bold ones.=C2=A0 Both are 70 in emacs 24.</div><div class=3D"g=
mail_msg"><br class=3D"gmail_msg"></div></div></div></blockquote><div><br><=
/div><div>This appears to be a regression from Emacs 24. Would be great if =
somebody who has knowledge about this area could look into this.=C2=A0</div=
></div></div>

--001a114b32cc3d9f33053c785eed--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#22780; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Feb 2016 07:19:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 23 02:19:13 2016
Received: from localhost ([127.0.0.1]:38905 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1aY7FX-0002o2-Bl
	for submit <at> debbugs.gnu.org; Tue, 23 Feb 2016 02:19:12 -0500
Received: from eggs.gnu.org ([208.118.235.92]:39576)
 by debbugs.gnu.org with esmtp (Exim 4.84)
 (envelope-from <alex@HIDDEN>) id 1aY5jE-0000KI-23
 for submit <at> debbugs.gnu.org; Tue, 23 Feb 2016 00:41:44 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alex@HIDDEN>) id 1aY5j7-00065c-CR
 for submit <at> debbugs.gnu.org; Tue, 23 Feb 2016 00:41:38 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,HTML_MESSAGE,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:59884)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <alex@HIDDEN>) id 1aY5j7-00065Y-8r
 for submit <at> debbugs.gnu.org; Tue, 23 Feb 2016 00:41:37 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:58766)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <alex@HIDDEN>) id 1aY5j5-00045U-PI
 for bug-gnu-emacs@HIDDEN; Tue, 23 Feb 2016 00:41:37 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alex@HIDDEN>) id 1aY5j2-00063A-Es
 for bug-gnu-emacs@HIDDEN; Tue, 23 Feb 2016 00:41:35 -0500
Received: from mail-ig0-x22a.google.com ([2607:f8b0:4001:c05::22a]:36687)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <alex@HIDDEN>) id 1aY5j1-00062G-SJ
 for bug-gnu-emacs@HIDDEN; Tue, 23 Feb 2016 00:41:32 -0500
Received: by mail-ig0-x22a.google.com with SMTP id xg9so92506056igb.1
 for <bug-gnu-emacs@HIDDEN>; Mon, 22 Feb 2016 21:41:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=khesin-com.20150623.gappssmtp.com; s=20150623;
 h=mime-version:from:date:message-id:subject:to;
 bh=kQYr2J7uq5GmXr6yVUiZSs5oMHk9G7D3BazzTdKCvtA=;
 b=IN70AOsotmWo44HSh3KKhaiRp+WP8vMIbm1T+Ib2pSqdhFKQgSrhoz7hBwXB/BKt/p
 IbqVHPfHNNjZ3tcaaPSHEYYc1yomDGXx5uFVL6H/RPU/8+/whhpsEtvRzpKa3lyGSIu6
 Uiuill4gbtOksnx6BXlNdRO0LCERK1VMwr6rU3v/4lV6e36t46xIhm6YUeedFlcwDASd
 1VnfGnJv28WfvtaNcTAMoyi1VkZZHd3CKD/QfG5Nt7RWYyik3EfNr0XQM5jYsyF1mRXl
 qCFpZgyLXQpYXxqCqZF47gYxdadaO3fYdP+KzncMt7NBplTZAP49ehdwGVGV6bR6fWYd
 B2pw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=kQYr2J7uq5GmXr6yVUiZSs5oMHk9G7D3BazzTdKCvtA=;
 b=QZ0QxdGGQp6rOw867y+bFEu3iqpyjlAimcYQ4GjLEQbp88g5uF9gD/vDbYx+NL3IAK
 2oIK95Om45Qqh5wJOdPEXORE6c1CfeoSRg5Dn0ITtIRC+LAZwCIiFfmFox1vMLs2zo8q
 mXe8P/dvJ56Auy1qL2NeqK4DU46e4oG6R0VMZi+G7b8Q8SR98Np/Yg+AMDF3gfHonGIT
 FqXTgwCtFW3+/x/Rg2kxNHeBzH+if1DZ0LWLckZOSzChPKO+p9G5sUp+nGWg/hKFoRy2
 LQfaRIaL1drBTzkJ70HUXf8M2EEFSTLbX7rVm4XKu+jATGI59TacykIU7a2mgOV2CXfj
 11qQ==
X-Gm-Message-State: AG10YOSH52IFmXnLpEnLsaCajnTG0/tk2zM5ny52JYDphcgQ94iTRNV+EIWZkq0DE+rxVquDzJQtxIjTgDPMTQ==
X-Received: by 10.50.28.20 with SMTP id x20mr15698889igg.87.1456206090753;
 Mon, 22 Feb 2016 21:41:30 -0800 (PST)
MIME-Version: 1.0
Received: by 10.64.143.10 with HTTP; Mon, 22 Feb 2016 21:41:11 -0800 (PST)
X-Originating-IP: [24.199.90.21]
From: Alex Khesin <alex@HIDDEN>
Date: Tue, 23 Feb 2016 00:41:11 -0500
Message-ID: <CAPt6kTOJ4VDkoAjm96hSQ_oSQXvXjR_2RnFcpJsBRg70vijuxQ@HIDDEN>
Subject: 25.1.50; wrong average width picked for bold face for 7x13 X11 font
To: bug-gnu-emacs@HIDDEN
Content-Type: multipart/alternative; boundary=089e01538d98c27911052c696625
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Tue, 23 Feb 2016 02:19:10 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

--089e01538d98c27911052c696625
Content-Type: text/plain; charset=UTF-8

emacs 25 choses fonts with different average width for 7x13 font, making
bold text take more horizontal space.  This is particularly a problem when
using themes like https://github.com/bbatsov/zenburn-emacs which use bold
to hihglight matching parenthesis in show-paren-mode, causing characters to
shift as the cursor is moved from a parenthesis to a non-parenthesis
character.

Repro that demonstrates the problem in both 25 pretest 1 and current head
(but is perfectly ok in emacs 24):

$ emacs -Q --eval '(progn (set-face-font '\''default "7x13") (print
(face-font "default")) (print (face-font "bold")))'

shows
  -misc-fixed-medium-r-normal--13-120-75-75-c-70-iso8859-1
  -misc-fixed-bold-r-normal--13-120-75-75-c-80-iso8859-1

Notice the jump from 70 to 80 before the iso8859 component - that's the
average width, and that's what I believe is causing bold characters to
render wider than non-bold ones.  Both are 70 in emacs 24.


Below is the diagnostics output from M-x report-emacs-bug:

In GNU Emacs 25.1.50.1 (x86_64-unknown-linux-gnu, X toolkit, Xaw3d scroll
bars)
 of 2016-02-22 built on alexk1
Repository revision: 81ef756e6aea369ec78f19b3609f01ceddc5851f
Windowing system distributor 'The X.Org Foundation', version 11.0.11501000
System Description: Ubuntu 14.04 LTS (upgraded from: Ubuntu 12.04.3 LTS)

Configured using:
 'configure --with-x-toolkit=lucid'

Configured features:
XAW3D XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK SOUND GPM DBUS GCONF
GSETTINGS NOTIFY GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB
TOOLKIT_SCROLL_BARS LUCID X11

Important settings:
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: @im=ibus
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Features:
(shadow sort mail-extr emacsbug message dired dired-loaddefs format-spec
rfc822 mml easymenu mml-sec password-cache epa derived epg epg-config
gnus-util rmail rmail-loaddefs mm-decode mm-bodies mm-encode mail-parse
rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045
ietf-drums mm-util mail-prsvr mail-utils time-date mule-util tooltip
eldoc electric uniquify ediff-hook vc-hooks lisp-float-type mwheel
term/x-win x-win term/common-win x-dnd tool-bar dnd fontset image
regexp-opt fringe tabulated-list newcomment elisp-mode lisp-mode
prog-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax facemenu font-core term/tty-colors frame
cl-generic cham georgian utf-8-lang misc-lang vietnamese tibetan thai
tai-viet lao korean japanese eucjp-ms cp51932 hebrew greek romanian
slovak czech european ethiopic indian cyrillic chinese charscript
case-table epa-hook jka-cmpr-hook help simple abbrev obarray minibuffer
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote dbusbind inotify
dynamic-setting system-font-setting font-render-setting x-toolkit x
multi-tty make-network-process emacs)

--089e01538d98c27911052c696625
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><div><div>emacs 25 choses fonts with different average wid=
th for 7x13 font, making bold text take more horizontal space.=C2=A0 This i=
s particularly a problem when using themes like <a href=3D"https://github.c=
om/bbatsov/zenburn-emacs">https://github.com/bbatsov/zenburn-emacs</a> whic=
h use bold to hihglight matching parenthesis in show-paren-mode, causing ch=
aracters to shift as the cursor is moved from a parenthesis to a non-parent=
hesis character.</div><div><br></div><div>Repro that demonstrates the probl=
em in both 25 pretest 1 and current head (but is perfectly ok in emacs 24):=
</div><div><br></div><div>$ emacs -Q --eval &#39;(progn (set-face-font &#39=
;\&#39;&#39;default &quot;7x13&quot;) (print (face-font &quot;default&quot;=
)) (print (face-font &quot;bold&quot;)))&#39;</div><div><br></div><div>show=
s</div><div><div>=C2=A0 -misc-fixed-medium-r-normal--13-120-75-75-c-70-iso8=
859-1</div><div>=C2=A0 -misc-fixed-bold-r-normal--13-120-75-75-c-80-iso8859=
-1</div></div><div><br></div><div>Notice the jump from 70 to 80 before the =
iso8859 component - that&#39;s the average width, and that&#39;s what I bel=
ieve is causing bold characters to render wider than non-bold ones.=C2=A0 B=
oth are 70 in emacs 24.</div><div><br></div><div><br></div><div>Below is th=
e diagnostics output from M-x report-emacs-bug:</div><div><br></div><div>In=
 GNU Emacs 25.1.50.1 (x86_64-unknown-linux-gnu, X toolkit, Xaw3d scroll bar=
s)</div><div>=C2=A0of 2016-02-22 built on alexk1</div><div>Repository revis=
ion: 81ef756e6aea369ec78f19b3609f01ceddc5851f</div><div>Windowing system di=
stributor &#39;The X.Org Foundation&#39;, version 11.0.11501000</div><div>S=
ystem Description:<span style=3D"white-space:pre-wrap">	</span>Ubuntu 14.04=
 LTS (upgraded from: Ubuntu 12.04.3 LTS)</div><div><br></div><div>Configure=
d using:</div><div>=C2=A0&#39;configure --with-x-toolkit=3Dlucid&#39;</div>=
<div><br></div><div>Configured features:</div><div>XAW3D XPM JPEG TIFF GIF =
PNG RSVG IMAGEMAGICK SOUND GPM DBUS GCONF</div><div>GSETTINGS NOTIFY GNUTLS=
 LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB</div><div>TOOLKIT_SCROLL_BARS LU=
CID X11</div><div><br></div><div>Important settings:</div><div>=C2=A0 value=
 of $LANG: en_US.UTF-8</div><div>=C2=A0 value of $XMODIFIERS: @im=3Dibus</d=
iv><div>=C2=A0 locale-coding-system: utf-8-unix</div><div><br></div><div>Ma=
jor mode: Lisp Interaction</div><div><br></div><div>Minor modes in effect:<=
/div><div>=C2=A0 tooltip-mode: t</div><div>=C2=A0 global-eldoc-mode: t</div=
><div>=C2=A0 electric-indent-mode: t</div><div>=C2=A0 mouse-wheel-mode: t</=
div><div>=C2=A0 tool-bar-mode: t</div><div>=C2=A0 menu-bar-mode: t</div><di=
v>=C2=A0 file-name-shadow-mode: t</div><div>=C2=A0 global-font-lock-mode: t=
</div><div>=C2=A0 font-lock-mode: t</div><div>=C2=A0 blink-cursor-mode: t</=
div><div>=C2=A0 auto-composition-mode: t</div><div>=C2=A0 auto-encryption-m=
ode: t</div><div>=C2=A0 auto-compression-mode: t</div><div>=C2=A0 line-numb=
er-mode: t</div><div>=C2=A0 transient-mark-mode: t</div><div><br></div><div=
>Features:<br></div><div>(shadow sort mail-extr emacsbug message dired dire=
d-loaddefs format-spec</div><div>rfc822 mml easymenu mml-sec password-cache=
 epa derived epg epg-config</div><div>gnus-util rmail rmail-loaddefs mm-dec=
ode mm-bodies mm-encode mail-parse</div><div>rfc2231 mailabbrev gmm-utils m=
ailheader sendmail rfc2047 rfc2045</div><div>ietf-drums mm-util mail-prsvr =
mail-utils time-date mule-util tooltip</div><div>eldoc electric uniquify ed=
iff-hook vc-hooks lisp-float-type mwheel</div><div>term/x-win x-win term/co=
mmon-win x-dnd tool-bar dnd fontset image</div><div>regexp-opt fringe tabul=
ated-list newcomment elisp-mode lisp-mode</div><div>prog-mode register page=
 menu-bar rfn-eshadow timer select scroll-bar</div><div>mouse jit-lock font=
-lock syntax facemenu font-core term/tty-colors frame</div><div>cl-generic =
cham georgian utf-8-lang misc-lang vietnamese tibetan thai</div><div>tai-vi=
et lao korean japanese eucjp-ms cp51932 hebrew greek romanian</div><div>slo=
vak czech european ethiopic indian cyrillic chinese charscript</div><div>ca=
se-table epa-hook jka-cmpr-hook help simple abbrev obarray minibuffer</div>=
<div>cl-preloaded nadvice loaddefs button faces cus-face macroexp files</di=
v><div>text-properties overlay sha1 md5 base64 format env code-pages mule</=
div><div>custom widget hashtable-print-readable backquote dbusbind inotify<=
/div><div>dynamic-setting system-font-setting font-render-setting x-toolkit=
 x</div><div>multi-tty make-network-process emacs)</div><div><br></div></di=
v></div>

--089e01538d98c27911052c696625--




Acknowledgement sent to Alex Khesin <alex@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#22780; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 14 Sep 2016 17:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.